export declare type AuthTokenPayload = {
    token_type: string;
    expires_in: number;
    access_token: string;
    scope: string;
    refresh_token: string;
};
export declare type ResponseTypeBasedProps<TData> = {
    responseType: 'code';
    exchangeCodeForTokenServerURL: string;
    exchangeCodeForTokenMethod?: 'POST' | 'GET';
    onSuccess?: (payload: TData) => void;
} | {
    responseType: 'token';
    onSuccess?: (payload: TData) => void;
};
export declare type Oauth2Props<TData = AuthTokenPayload> = {
    authorizeUrl: string;
    clientId: string;
    redirectUri: string;
    scope?: string;
    extraQueryParameters?: Record<string, any>;
    onError?: (error: string) => void;
} & ResponseTypeBasedProps<TData>;
export declare type State<TData = AuthTokenPayload> = TData | null;
declare const useOAuth2: <TData = AuthTokenPayload>(props: Oauth2Props<TData>) => {
    data: State<AuthTokenPayload>;
    loading: boolean;
    error: null;
    getAuth: () => () => void;
};
export default useOAuth2;
